Index: libcfa/src/heap.cfa
===================================================================
--- libcfa/src/heap.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/heap.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -10,6 +10,6 @@
 // Created On       : Tue Dec 19 21:58:35 2017
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Wed Dec 16 12:28:25 2020
-// Update Count     : 1023
+// Last Modified On : Tue Dec 15 21:37:54 2020
+// Update Count     : 1013
 //
 
@@ -438,5 +438,5 @@
 	header = headerAddr( addr );
 
-  if ( unlikely( addr < heapBegin || heapEnd < addr ) ) { // mmapped ?
+  if ( unlikely( heapEnd < addr ) ) {					// mmapped ?
 		fakeHeader( header, alignment );
 		size = header->kind.real.blockSize & -3;		// mmap size
@@ -445,5 +445,5 @@
 
 	#ifdef __CFA_DEBUG__
-	checkHeader( header < (HeapManager.Storage.Header *)heapBegin, name, addr ); // bad low address ?
+	checkHeader( addr < heapBegin, name, addr );		// bad low address ?
 	#endif // __CFA_DEBUG__
 
@@ -484,7 +484,7 @@
 #endif // __CFA_DEBUG__
 
-
 #define NO_MEMORY_MSG "insufficient heap memory available for allocating %zd new bytes."
 
+#include <unistd.h>
 static inline void * extend( size_t size ) with( heapManager ) {
 	lock( extlock __cfaabi_dbg_ctx2 );
@@ -511,5 +511,5 @@
 		#ifdef __CFA_DEBUG__
 		// Set new memory to garbage so subsequent uninitialized usages might fail.
-		memset( (char *)heapEnd + heapRemaining, '\xde', increase );
+		memset( (char *)heapEnd + heapRemaining, '\hde', increase );
 		//Memset( (char *)heapEnd + heapRemaining, increase );
 		#endif // __CFA_DEBUG__
@@ -586,5 +586,5 @@
 		#ifdef __CFA_DEBUG__
 		// Set new memory to garbage so subsequent uninitialized usages might fail.
-		memset( block, '\xde', tsize );
+		memset( block, '\hde', tsize );
 		//Memset( block, tsize );
 		#endif // __CFA_DEBUG__
@@ -634,5 +634,5 @@
 		#ifdef __CFA_DEBUG__
 		// Set free memory to garbage so subsequent usages might fail.
-		memset( ((HeapManager.Storage *)header)->data, '\xde', freeElem->blockSize - sizeof( HeapManager.Storage ) );
+		memset( ((HeapManager.Storage *)header)->data, '\hde', freeElem->blockSize - sizeof( HeapManager.Storage ) );
 		//Memset( ((HeapManager.Storage *)header)->data, freeElem->blockSize - sizeof( HeapManager.Storage ) );
 		#endif // __CFA_DEBUG__
@@ -1029,5 +1029,4 @@
 	} // cmemalign
 
-
 	// Same as memalign(), but ISO/IEC 2011 C11 Section 7.22.2 states: the value of size shall be an integral multiple
     // of alignment. This requirement is universally ignored.
@@ -1046,5 +1045,4 @@
 		return 0;
 	} // posix_memalign
-
 
 	// Allocates size bytes and returns a pointer to the allocated memory. The memory address shall be a multiple of the
Index: libcfa/src/memory.cfa
===================================================================
--- libcfa/src/memory.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/memory.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -66,5 +66,5 @@
 forall(dtype T | sized(T), ttype Args | { void ?{}(T&, Args); })
 void ?{}(counter_ptr(T) & this, Args args) {
-	this.data = (counter_data(T)*)new(args);
+	this.data = new(args);
 }
 
@@ -126,5 +126,5 @@
 forall(dtype T | sized(T), ttype Args | { void ?{}(T &, Args); })
 void ?{}(unique_ptr(T) & this, Args args) {
-	this.data = (T *)new(args);
+	this.data = new(args);
 }
 
Index: libcfa/src/parseargs.cfa
===================================================================
--- libcfa/src/parseargs.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/parseargs.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -105,5 +105,4 @@
 					if(opt == options[i].short_name) {
 						const char * arg = optarg ? optarg : "";
-						if( arg[0] == '=' ) { arg++; }
 						bool success = options[i].parse( arg, options[i].variable );
 						if(success) continue NEXT_ARG;
@@ -186,18 +185,4 @@
 }
 
-bool parse_truefalse(const char * arg, bool & value) {
-	if(strcmp(arg, "true") == 0) {
-		value = true;
-		return true;
-	}
-
-	if(strcmp(arg, "false") == 0) {
-		value = false;
-		return true;
-	}
-
-	return false;
-}
-
 bool parse_settrue (const char *, bool & value ) {
 	value = true;
Index: libcfa/src/parseargs.hfa
===================================================================
--- libcfa/src/parseargs.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/parseargs.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -37,8 +37,7 @@
 void print_args_usage(int argc, char * argv[], cfa_option options[], size_t opt_count, const char * usage, bool error)  __attribute__ ((noreturn));
 
-bool parse_yesno    (const char *, bool & );
-bool parse_truefalse(const char *, bool & );
-bool parse_settrue  (const char *, bool & );
-bool parse_setfalse (const char *, bool & );
+bool parse_yesno   (const char *, bool & );
+bool parse_settrue (const char *, bool & );
+bool parse_setfalse(const char *, bool & );
 
 bool parse(const char *, const char * & );
Index: libcfa/src/stdlib.hfa
===================================================================
--- libcfa/src/stdlib.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/stdlib.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -267,5 +267,5 @@
 static inline forall( dtype T | sized(T), ttype TT | { void ?{}( T &, TT ); } )
 T * new( TT p ) {
-	return &(*(T *)malloc()){ p };							// run constructor
+	return &(*malloc()){ p };							// run constructor
 } // new
 
Index: longrun_tests/Makefile.am
===================================================================
--- longrun_tests/Makefile.am	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ longrun_tests/Makefile.am	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -44,5 +44,5 @@
 	-DTEST_$(shell cat .type | tr a-z A-Z)
 
-TESTS = block coroutine create disjoint enter enter3 locks processor stack wait yield
+TESTS = block coroutine create disjoint enter enter3 processor stack wait yield
 
 # .INTERMEDIATE: $(TESTS)
Index: src/AST/Convert.cpp
===================================================================
--- src/AST/Convert.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Convert.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -205,10 +205,5 @@
 		ftype->parameters = get<DeclarationWithType>().acceptL(node->params);
 
-		ftype->forall = get<TypeDecl>().acceptL( node->type_params );
-		if (!node->assertions.empty()) {
-			assert(!ftype->forall.empty());
-			// find somewhere to place assertions back, for convenience it is the last slot
-			ftype->forall.back()->assertions = get<DeclarationWithType>().acceptL(node->assertions);
-		}
+		ftype->forall = get<TypeDecl>().acceptL( node->type->forall );
 
 		visitType(node->type, ftype);
@@ -607,6 +602,11 @@
 
 		for (decltype(src->begin()) src_i = src->begin(); src_i != src->end(); src_i++) {
-			rslt->add( src_i->first.typeString(),
+			rslt->add( src_i->first,
 			           get<Type>().accept1(src_i->second) );
+		}
+
+		for (decltype(src->beginVar()) src_i = src->beginVar(); src_i != src->endVar(); src_i++) {
+			rslt->addVar( src_i->first,
+			              get<Expression>().accept1(src_i->second) );
 		}
 
@@ -1212,25 +1212,5 @@
 		// ty->returnVals = get<DeclarationWithType>().acceptL( node->returns );
 		// ty->parameters = get<DeclarationWithType>().acceptL( node->params );
-
-		auto types = get<TypeInstType>().acceptL( node->forall );
-		for (auto t : types) {
-			auto newT = new TypeDecl(*t->baseType);
-			newT->name = t->name; // converted by typeString()
-			for (auto asst : newT->assertions) delete asst;
-			newT->assertions.clear();
-			ty->forall.push_back(newT);
-		}
-		auto assts = get<VariableExpr>().acceptL( node->assertions );
-		if (!assts.empty()) {
-			assert(!types.empty());
-			for (auto asst : assts) {
-				auto newDecl = new ObjectDecl(*strict_dynamic_cast<ObjectDecl*>(asst->var));
-				delete newDecl->type;
-				newDecl->type = asst->result->clone();
-				newDecl->storageClasses.is_extern = true; // hack
-				ty->forall.back()->assertions.push_back(newDecl);
-			}
-		}
-
+		ty->forall = get<TypeDecl>().acceptL( node->forall );
 		return visitType( node, ty );
 	}
@@ -1319,5 +1299,5 @@
 			ty = new TypeInstType{
 				cv( node ),
-				node->typeString(),
+				node->name,
 				get<TypeDecl>().accept1( node->base ),
 				get<Attribute>().acceptL( node->attributes )
@@ -1326,5 +1306,5 @@
 			ty = new TypeInstType{
 				cv( node ),
-				node->typeString(),
+				node->name,
 				node->kind == ast::TypeDecl::Ftype,
 				get<Attribute>().acceptL( node->attributes )
@@ -1451,5 +1431,5 @@
 	/// at conversion stage, all created nodes are guaranteed to be unique, therefore
 	/// const_casting out of smart pointers is permitted.
-	std::unordered_map< const BaseSyntaxNode *, ast::readonly<ast::Node> > cache = {};
+	std::unordered_map< const BaseSyntaxNode *, ast::ptr<ast::Node> > cache = {};
 
 	// Local Utilities:
@@ -1585,16 +1565,4 @@
 		// can function type have attributes? seems not to be the case.
 		// visitType(old->type, ftype);
-
-		// collect assertions and put directly in FunctionDecl
-		std::vector<ast::ptr<ast::DeclWithType>> assertions;
-		for (auto & param: forall) {
-			for (auto & asst: param->assertions) {
-				assertf(asst->unique(), "newly converted decl must be unique");
-				assertions.emplace_back(asst);
-			}
-			auto mut = param.get_and_mutate();
-			assertf(mut == param, "newly converted decl must be unique");
-			mut->assertions.clear();
-		}
 
 		auto decl = new ast::FunctionDecl{
@@ -1616,5 +1584,4 @@
 		cache.emplace( old, decl );
 
-		decl->assertions = std::move(assertions);
 		decl->withExprs = GET_ACCEPT_V(withExprs, Expr);
 		decl->stmts = GET_ACCEPT_1(statements, CompoundStmt);
@@ -2099,12 +2066,8 @@
 	}
 
-	// TypeSubstitution shouldn't exist yet in old.
 	ast::TypeSubstitution * convertTypeSubstitution(const TypeSubstitution * old) {
-		
+
 		if (!old) return nullptr;
-		if (old->empty()) return nullptr;
-		assert(false);
-
-		/*
+
 		ast::TypeSubstitution *rslt = new ast::TypeSubstitution();
 
@@ -2114,6 +2077,10 @@
 		}
 
+		for (decltype(old->beginVar()) old_i = old->beginVar(); old_i != old->endVar(); old_i++) {
+			rslt->addVar( old_i->first,
+			              getAccept1<ast::Expr>(old_i->second) );
+		}
+
 		return rslt;
-		*/
 	}
 
@@ -2643,14 +2610,5 @@
 			ty->params.emplace_back(v->get_type());
 		}
-		// xxx - when will this be non-null?
-		// will have to create dangling (no-owner) decls to be pointed to
-		auto foralls = GET_ACCEPT_V( forall, TypeDecl );
-
-		for (auto & param : foralls) {
-			ty->forall.emplace_back(new ast::TypeInstType(param->name, param));
-			for (auto asst : param->assertions) {
-				ty->assertions.emplace_back(new ast::VariableExpr({}, asst));
-			}
-		}
+		ty->forall = GET_ACCEPT_V( forall, TypeDecl );
 		visitType( old, ty );
 	}
Index: src/AST/Decl.cpp
===================================================================
--- src/AST/Decl.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Decl.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -50,22 +50,20 @@
 
 FunctionDecl::FunctionDecl( const CodeLocation & loc, const std::string & name, 
-	std::vector<ptr<TypeDecl>>&& forall,
-	std::vector<ptr<DeclWithType>>&& params, std::vector<ptr<DeclWithType>>&& returns,
-	CompoundStmt * stmts, Storage::Classes storage, Linkage::Spec linkage,
-	std::vector<ptr<Attribute>>&& attrs, Function::Specs fs, bool isVarArgs)
-: DeclWithType( loc, name, storage, linkage, std::move(attrs), fs ), params(std::move(params)), returns(std::move(returns)),
-	type_params(std::move(forall)), stmts( stmts ) {
-	FunctionType * ftype = new FunctionType(static_cast<ArgumentFlag>(isVarArgs));
-	for (auto & param : this->params) {
-		ftype->params.emplace_back(param->get_type());
-	}
-	for (auto & ret : this->returns) {
-		ftype->returns.emplace_back(ret->get_type());
-	}
-	for (auto & tp : this->type_params) {
-		ftype->forall.emplace_back(new TypeInstType(tp->name, tp));
-	}
-	this->type = ftype;
-}
+		std::vector<ptr<TypeDecl>>&& forall,
+		std::vector<ptr<DeclWithType>>&& params, std::vector<ptr<DeclWithType>>&& returns,
+		CompoundStmt * stmts, Storage::Classes storage, Linkage::Spec linkage,
+		std::vector<ptr<Attribute>>&& attrs, Function::Specs fs, bool isVarArgs)
+	: DeclWithType( loc, name, storage, linkage, std::move(attrs), fs ), params(std::move(params)), returns(std::move(returns)),
+	  stmts( stmts ) {
+		  FunctionType * ftype = new FunctionType(static_cast<ArgumentFlag>(isVarArgs));
+		  for (auto & param : this->params) {
+			  ftype->params.emplace_back(param->get_type());
+		  }
+		  for (auto & ret : this->returns) {
+			  ftype->returns.emplace_back(ret->get_type());
+		  }
+		  ftype->forall = std::move(forall);
+		  this->type = ftype;
+	  }
 
 
Index: src/AST/Decl.hpp
===================================================================
--- src/AST/Decl.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Decl.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -127,11 +127,8 @@
 	std::vector<ptr<DeclWithType>> params;
 	std::vector<ptr<DeclWithType>> returns;
-	std::vector<ptr<TypeDecl>> type_params;
-	std::vector<ptr<DeclWithType>> assertions;
 	// declared type, derived from parameter declarations
 	ptr<FunctionType> type;
 	ptr<CompoundStmt> stmts;
 	std::vector< ptr<Expr> > withExprs;
-
 
 	FunctionDecl( const CodeLocation & loc, const std::string & name, std::vector<ptr<TypeDecl>>&& forall,
Index: src/AST/Expr.cpp
===================================================================
--- src/AST/Expr.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Expr.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -206,5 +206,40 @@
 	assert( aggregate->result );
 
-	result = mem->get_type();
+	// Deep copy on result type avoids mutation on transitively multiply referenced object.
+	//
+	// Example, adapted from parts of builtins and bootloader:
+	//
+	// forall(dtype T)
+	// struct __Destructor {
+	//   T * object;
+	//   void (*dtor)(T *);
+	// };
+	//
+	// forall(dtype S)
+	// void foo(__Destructor(S) &d) {
+	//   if (d.dtor) {  // here
+	//   }
+	// }
+	//
+	// Let e be the "d.dtor" guard espression, which is MemberExpr after resolve.  Let d be the
+	// declaration of member __Destructor.dtor (an ObjectDecl), as accessed via the top-level
+	// declaration of __Destructor.  Consider the types e.result and d.type.  In the old AST, one
+	// is a clone of the other.  Ordinary new-AST use would set them up as a multiply-referenced
+	// object.
+	//
+	// e.result: PointerType
+	// .base: FunctionType
+	// .params.front(): ObjectDecl, the anonymous parameter of type T*
+	// .type: PointerType
+	// .base: TypeInstType
+	// let x = that
+	// let y = similar, except start from d.type
+	//
+	// Consider two code lines down, genericSubstitution(...).apply(result).
+	//
+	// Applying this chosen-candidate's type substitution means modifying x, substituting
+	// S for T.  This mutation should affect x and not y.
+
+	result = deepCopy(mem->get_type());
 
 	// substitute aggregate generic parameters into member type
Index: src/AST/ForallSubstitutionTable.cpp
===================================================================
--- src/AST/ForallSubstitutionTable.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ src/AST/ForallSubstitutionTable.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,54 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// ForallSubstitutionTable.cpp --
+//
+// Author           : Aaron B. Moss
+// Created On       : Thu Jun 27 14:00:00 2019
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Thu Jun 27 14:00:00 2019
+// Update Count     : 1
+//
+
+#include "ForallSubstitutionTable.hpp"
+
+#include <cassert>
+#include <vector>
+
+#include "Copy.hpp"                // for shallowCopy
+#include "Decl.hpp"
+#include "Node.hpp"
+#include "Type.hpp"
+#include "Visitor.hpp"
+
+namespace ast {
+
+std::vector< ptr< TypeDecl > > ForallSubstitutionTable::clone(
+	const std::vector< ptr< TypeDecl > > & forall, Visitor & v
+) {
+	std::vector< ptr< TypeDecl > > new_forall;
+	new_forall.reserve( forall.size() );
+
+	for ( const ast::TypeDecl * d : forall ) {
+		// create cloned type decl and insert into substitution map before further mutation
+		auto new_d = shallowCopy( d );
+		decls.insert( d, new_d );
+		// perform other mutations and add to output
+		auto newer_d = v.visit( new_d );
+		assert( new_d == newer_d && "Newly cloned TypeDecl must retain identity" );
+		new_forall.emplace_back( new_d );
+	}
+
+	return new_forall;
+}
+
+}
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/AST/ForallSubstitutionTable.hpp
===================================================================
--- src/AST/ForallSubstitutionTable.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ src/AST/ForallSubstitutionTable.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,57 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// ForallSubstitutionTable.hpp --
+//
+// Author           : Aaron B. Moss
+// Created On       : Thu Jun 27 14:00:00 2019
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Thu Jun 27 14:00:00 2019
+// Update Count     : 1
+//
+
+#pragma once
+
+#include <vector>
+
+#include "Node.hpp"  // for ptr
+#include "Common/ScopedMap.h"
+
+namespace ast {
+
+class TypeDecl;
+class Visitor;
+
+/// Wrapper for TypeDecl substitution table
+class ForallSubstitutionTable {
+	ScopedMap< const TypeDecl *, const TypeDecl * > decls;
+
+public:
+	/// Replaces given declaration with value in the table, if present, otherwise returns argument
+	const TypeDecl * replace( const TypeDecl * d ) {
+		auto it = decls.find( d );
+		if ( it != decls.end() ) return it->second;
+		return d;
+	}
+
+	/// Builds a new forall list mutated according to the given visitor
+	std::vector< ptr< TypeDecl > > clone( 
+		const std::vector< ptr< TypeDecl > > & forall, Visitor & v );
+
+	/// Introduces a new lexical scope
+	void beginScope() { decls.beginScope(); }
+
+	/// Concludes a lexical scope
+	void endScope() { decls.endScope(); }
+};
+
+}
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/AST/ForallSubstitutor.hpp
===================================================================
--- src/AST/ForallSubstitutor.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ src/AST/ForallSubstitutor.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,70 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// ForallSubstitutor.hpp --
+//
+// Author           : Aaron B. Moss
+// Created On       : Wed Jun 26 15:00:00 2019
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Wed Jun 26 15:00:00 2019
+// Update Count     : 1
+//
+
+#include "Pass.hpp"
+
+namespace ast {
+
+class Expr;
+
+/// Visitor that correctly substitutes TypeDecl while maintaining TypeInstType bindings.
+/// Also has some convenience methods to mutate fields.
+struct ForallSubstitutor : public WithForallSubstitutor, public WithVisitorRef<ForallSubstitutor> {
+	/// Substitute TypeInstType base type
+	readonly< TypeDecl > operator() ( const readonly< TypeDecl > & o ) {
+		return subs.replace( o );
+	}
+	
+	/// Make new forall-list clone
+	FunctionType::ForallList operator() ( const FunctionType::ForallList & o ) {
+		return subs.clone( o, *visitor );
+	}
+
+	template<typename node_t > 
+	std::vector<ptr<node_t>> operator() (const std::vector<ptr<node_t>> & o) {
+		std::vector<ptr<node_t>> n;
+		n.reserve(o.size());
+		for (const node_t * d : o) { n.emplace_back(d->accept(*visitor)); }
+		return n;
+	}
+	
+	/*
+
+	/// Substitute parameter/return type
+	std::vector< ptr< DeclWithType > > operator() ( const std::vector< ptr< DeclWithType > > & o ) {
+		std::vector< ptr< DeclWithType > > n;
+		n.reserve( o.size() );
+		for ( const DeclWithType * d : o ) { n.emplace_back( d->accept( *visitor ) ); }
+		return n;
+	}
+
+	/// Substitute type parameter list
+	std::vector< ptr< Expr > > operator() ( const std::vector< ptr< Expr > > & o ) {
+		std::vector< ptr< Expr > > n;
+		n.reserve( o.size() );
+		for ( const Expr * d : o ) { n.emplace_back( d->accept( *visitor ) ); }
+		return n;
+	}
+
+	*/
+};
+
+} // namespace ast
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/AST/Node.hpp
===================================================================
--- src/AST/Node.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Node.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -229,6 +229,5 @@
 	const node_t & operator* () const { _check(); return *node; }
 	explicit operator bool() const { _check(); return node; }
-	operator const node_t * () const & { _check(); return node; }
-	operator const node_t * () && = delete;
+	operator const node_t * () const { _check(); return node; }
 
 	const node_t * release() {
Index: src/AST/Pass.hpp
===================================================================
--- src/AST/Pass.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Pass.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -34,4 +34,6 @@
 
 #include "AST/SymbolTable.hpp"
+
+#include "AST/ForallSubstitutionTable.hpp"
 
 // Private prelude header, needed for some of the magic tricks this class pulls off
@@ -64,4 +66,5 @@
 // | WithVisitorRef        - provides an pointer to the templated visitor wrapper
 // | WithSymbolTable       - provides symbol table functionality
+// | WithForallSubstitutor - maintains links between TypeInstType and TypeDecl under mutation
 //
 // Other Special Members:
@@ -255,4 +258,8 @@
 	container_t< ptr<node_t> > call_accept( const container_t< ptr<node_t> > & container );
 
+	/// Mutate forall-list, accounting for presence of type substitution map
+	template<typename node_t>
+	void mutate_forall( const node_t *& );
+
 public:
 	/// Logic to call the accept and mutate the parent if needed, delegates call to accept
@@ -391,4 +398,9 @@
 };
 
+/// Use when the templated visitor needs to keep TypeInstType instances properly linked to TypeDecl
+struct WithForallSubstitutor {
+	ForallSubstitutionTable subs;
+};
+
 }
 
Index: src/AST/Pass.impl.hpp
===================================================================
--- src/AST/Pass.impl.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Pass.impl.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -367,4 +367,20 @@
 	}
 
+
+	template< typename core_t >
+	template< typename node_t >
+	void ast::Pass< core_t >::mutate_forall( const node_t *& node ) {
+		if ( auto subs = __pass::forall::subs( core, 0 ) ) {
+			// tracking TypeDecl substitution, full clone
+			if ( node->forall.empty() ) return;
+
+			node_t * mut = __pass::mutate<core_t>( node );
+			mut->forall = subs->clone( node->forall, *this );
+			node = mut;
+		} else {
+			// not tracking TypeDecl substitution, just mutate
+			maybe_accept( node, &node_t::forall );
+		}
+	}
 }
 
@@ -488,10 +504,9 @@
 			__pass::symtab::addId( core, 0, func );
 			VISIT(
-				// parameter declarations
+				// parameter declarations are now directly here
 				maybe_accept( node, &FunctionDecl::params );
 				maybe_accept( node, &FunctionDecl::returns );
-				// type params and assertions
-				maybe_accept( node, &FunctionDecl::type_params );
-				maybe_accept( node, &FunctionDecl::assertions );
+				// foralls are still in function type
+				maybe_accept( node, &FunctionDecl::type );
 				// First remember that we are now within a function.
 				ValueGuard< bool > oldInFunction( inFunction );
@@ -1743,7 +1758,6 @@
 
 	VISIT({
-		// guard_forall_subs forall_guard { *this, node };
-		// mutate_forall( node );
-		maybe_accept( node, &FunctionType::assertions );
+		guard_forall_subs forall_guard { *this, node };
+		mutate_forall( node );
 		maybe_accept( node, &FunctionType::returns );
 		maybe_accept( node, &FunctionType::params  );
@@ -1967,5 +1981,5 @@
 		{
 			bool mutated = false;
-			std::unordered_map< ast::TypeInstType::TypeEnvKey, ast::ptr< ast::Type > > new_map;
+			std::unordered_map< std::string, ast::ptr< ast::Type > > new_map;
 			for ( const auto & p : node->typeEnv ) {
 				guard_symtab guard { *this };
@@ -1980,4 +1994,20 @@
 			}
 		}
+
+		{
+			bool mutated = false;
+			std::unordered_map< std::string, ast::ptr< ast::Expr > > new_map;
+			for ( const auto & p : node->varEnv ) {
+				guard_symtab guard { *this };
+				auto new_node = p.second->accept( *this );
+				if (new_node != p.second) mutated = true;
+				new_map.insert({ p.first, new_node });
+			}
+			if (mutated) {
+				auto new_node = __pass::mutate<core_t>( node );
+				new_node->varEnv.swap( new_map );
+				node = new_node;
+			}
+		}
 	)
 
Index: src/AST/Pass.proto.hpp
===================================================================
--- src/AST/Pass.proto.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Pass.proto.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -413,4 +413,13 @@
 		static inline auto leave( core_t &, long, const ast::FunctionType * ) {}
 
+		// Get the substitution table, if present
+		template<typename core_t>
+		static inline auto subs( core_t & core, int ) -> decltype( &core.subs ) {
+			return &core.subs;
+		}
+
+		template<typename core_t>
+		static inline ast::ForallSubstitutionTable * subs( core_t &, long ) { return nullptr; }
+
 		// Replaces a TypeInstType's base TypeDecl according to the table
 		template<typename core_t>
Index: src/AST/Print.cpp
===================================================================
--- src/AST/Print.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Print.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -155,13 +155,4 @@
 	}
 
-	void print( const ast::FunctionType::AssertionList & assts ) {
-		if (assts.empty()) return;
-		os << "with assertions" << endl;
-		++indent;
-		printAll(assts);
-		os << indent;
-		--indent;
-	}
-
 	void print( const std::vector<ptr<Attribute>> & attrs ) {
 		if ( attrs.empty() ) return;
@@ -215,5 +206,6 @@
 	void preprint( const ast::NamedTypeDecl * node ) {
 		if ( ! node->name.empty() ) {
-			os << node->name << ": ";
+			if( deterministic_output && isUnboundType(node->name) ) os << "[unbound]:";
+			else os << node->name << ": ";
 		}
 
@@ -269,5 +261,4 @@
 	void preprint( const ast::FunctionType * node ) {
 		print( node->forall );
-		print( node->assertions );
 		print( node->qualifiers );
 	}
@@ -1384,5 +1375,5 @@
 	virtual const ast::Type * visit( const ast::TypeInstType * node ) override final {
 		preprint( node );
-		const auto & _name = deterministic_output && isUnboundType(node) ? "[unbound]" : node->typeString();
+		const auto & _name = deterministic_output && isUnboundType(node) ? "[unbound]" : node->name;
 		os << "instance of type " << _name
 		   << " (" << (node->kind == ast::TypeDecl::Ftype ? "" : "not ") << "function type)";
@@ -1511,7 +1502,15 @@
 		os << indent << "Types:" << endl;
 		for ( const auto& i : *node ) {
-			os << indent+1 << i.first.typeString() << " -> ";
+			os << indent+1 << i.first << " -> ";
 			indent += 2;
 			safe_print( i.second );
+			indent -= 2;
+			os << endl;
+		}
+		os << indent << "Non-types:" << endl;
+		for ( auto i = node->beginVar(); i != node->endVar(); ++i ) {
+			os << indent+1 << i->first << " -> ";
+			indent += 2;
+			safe_print( i->second );
 			indent -= 2;
 			os << endl;
Index: src/AST/SymbolTable.cpp
===================================================================
--- src/AST/SymbolTable.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/SymbolTable.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -414,11 +414,5 @@
 
 void SymbolTable::addFunction( const FunctionDecl * func ) {
-	for (auto & td : func->type_params) {
-		addType(td);
-	}
-	for (auto & asst : func->assertions) {
-		addId(asst);
-	}
-	// addTypes( func->type->forall );
+	addTypes( func->type->forall );
 	addIds( func->returns );
 	addIds( func->params );
Index: src/AST/Type.cpp
===================================================================
--- src/AST/Type.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Type.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -21,4 +21,5 @@
 
 #include "Decl.hpp"
+#include "ForallSubstitutor.hpp" // for substituteForall
 #include "Init.hpp"
 #include "Common/utility.h"      // for copy, move
@@ -91,5 +92,24 @@
 // GENERATED END
 
+// --- ParameterizedType
+
+void FunctionType::initWithSub(
+	const FunctionType & o, Pass< ForallSubstitutor > & sub
+) {
+	forall = sub.core( o.forall );
+}
+
 // --- FunctionType
+
+
+FunctionType::FunctionType( const FunctionType & o )
+: Type( o.qualifiers, copy( o.attributes ) ), returns(), params(),
+  isVarArgs( o.isVarArgs ) {
+	Pass< ForallSubstitutor > sub;
+	initWithSub( o, sub );           // initialize substitution map
+	returns = sub.core( o.returns ); // apply to return and parameter types
+	params = sub.core( o.params );
+}
+
 namespace {
 	bool containsTtype( const std::vector<ptr<Type>> & l ) {
@@ -179,5 +199,16 @@
 		// TODO: once TypeInstType representation is updated, it should properly check
 		// if the context id is filled. this is a temporary hack for now
-		return typeInst->formal_usage > 0;
+		return isUnboundType(typeInst->name);
+	}
+	return false;
+}
+
+bool isUnboundType(const std::string & tname) {
+	// xxx - look for a type name produced by renameTyVars.
+
+	// TODO: once TypeInstType representation is updated, it should properly check
+	// if the context id is filled. this is a temporary hack for now
+	if (std::count(tname.begin(), tname.end(), '_') >= 3) {
+		return true;
 	}
 	return false;
